<template>
    <div>
        <div class="alert alert-primary cartlable" v-if="cartCount !== 0" role="alert">
            Cart
        </div>
        <div class="alert alert-danger cartlable" v-if="cartCount === 0" role="alert">
            Cart is Empty
        </div>
        <div class="wrapper">

            <ul class="list-group">
                <li class="list-group-item" v-for="listing in cartListings" :key="listing.id">
                    <Listing v-bind="listing"></Listing>
                </li>
            </ul>
            <div class="button">

                <button type="button" v-if="cartCount !== 0" class="btn btn-success btn-lg" @click.prevent="buy">
                    Buy
                </button>

            </div>

        </div>


        <div class="orders">
            <div class="alert alert-primary" role="alert">
                Orders : {{ordersCount}}
            </div>

            <div class="row">
                <div class="col-sm-6" v-for="listing in orders" :key="listing.id">
                    <div class="card">
                        <div class="card-body">
                            <h5 class="card-title">{{listing.title}}</h5>
                            <p class="card-text">{{listing.description}}</p>
                            <p class="card-text">{{listing.address}}</p>
                            <p class="card-text">{{listing.rooms}} rooms</p>
                            <p class="card-text">{{listing.price}} $</p>
                        </div>
                    </div>
                </div>
            </div>

        </div>

    </div>


</template>

<script>
    import {mapGetters, mapState} from 'vuex'
    import Listing from "./Listing";

    export default {
        name: "Cart",
        components: {Listing},
        computed:{
            ...mapState({
            cartListings: state => state.cart.listings,
            orders: state => state.orders.listings
        }),
            ...mapGetters([
                'cartCount',
                'ordersCount',
            ])
        },
        mounted() {
            this.$store.dispatch('getOrders').then(response => this.onSuccess(response)).catch(response => this.onError(response));
        },
        methods: {
            async buy() {
                await this.$store.dispatch('buy', this.cartListings.map(listing => listing.id)).then()
                await this.$store.dispatch('getOrders').then(response => this.onSuccess(response)).catch(response => this.onError(response));
                await this.$store.dispatch('getCart',).then(response => this.$store.dispatch('setCart', response.data)).catch(response => this.onError(response));
            },
            onSuccess(response) {
                this.$store.dispatch('setOrders', response.data)
                // this.$store.dispatch('setCurrentPage', response.data.current_page)
                // this.$store.dispatch('setLastPage', response.data.last_page)
            },
            onError(response) {
                console.log(response)
            },
        }
    }
</script>

<style scoped>

    .cartlable {
        margin-right: 150px;
        margin-left: 40px;
    }

    .orders {
        margin-right: 150px;
        margin-left: 40px;
        margin-bottom: 100px;
    }

    .wrapper {
        display: flex;
        flex-direction: row;
        align-items: flex-start;
        justify-content: space-between;
        width: 100%;
        margin-bottom: 100px;
    }

    .list-group {

        margin-left: 40px;
    }

    .button {
        align-self: flex-start;
        margin-right: 150px;
        margin-left: 150px;
        margin-top: 10px;
        margin-bottom: 100px;
    }

    .btn {
        width: 200px;
    }
</style>
